﻿import numpy as np

def Aleatoire(L): # fonction calculant une valeur au hasard une valeur
    tirage = np.random.normal() # tirage entre -infini et +infini (loi normale)
    return L[0] + L[1]*tirage

# Saisie des valeurs avec leur incertitude-type sous la forme grandeur= [valeur, incertitude]
D = [ 0 , 0] # Distance fentes écran en mètre
d = [ 0, 0] # Taille de la tache centrale en mètre
LongeurDOnde= 0 #m

dFil = [] 
iteration = 100000 # 100 000 valeurs aléatoires générées

for i in range(iteration):
    Aleatoire_dFil = 2*Aleatoire(D)/(Aleatoire(d))*LongeurDOnde
    dFil.append(Aleatoire_dFil)

Moy_dFil = sum(dFil)/iteration # Diamètre du fil d_Fil
U_dFil = (1/(iteration -1)*sum((np.array(dFil) - Moy_dFil)**2))**0.5 # calcul de l’incertitude diamètre du fil U(d_Fil).

print('Diamètre du fil d_Fil=', round(Moy_dFil*1e6,5), "µm")
print('Incertitude diamètre du fil U(d_Fil)=',round(U_dFil*1e6,5) , "µm")